function [sys,x0,str,ts] = vym(t,x,u,flag)
 
switch flag,
case 0
   [sys,x0,str,ts] = mdlInitializeSizes;
case 1
   sys = mdlDerivatives(t,x,u);
case 3
   sys = mdlOutputs(t,x,u);
case {2, 4, 9}
   sys = [];
otherwise
   error(['unhandled flag = ',num2str(flag)]);
end;
 
function [sys,x0,str,ts] = mdlInitializeSizes % inicializacia: do tejto funkcie vkladame vlastne udaje
sizes = simsizes;
sizes.NumContStates  = 3; % pocet spojitych stavov
sizes.NumDiscStates  = 0; % pocet diskretnych stavov
sizes.NumOutputs     = 3; % pocet vystupov
sizes.NumInputs      = 3; % pocet vstupov
sizes.DirFeedthrough = 0; % = 0 v pripade, ze v rovniciach vystupu nevystupuje u alebo nevystupuje matica D. Inak =1.
sizes.NumSampleTimes = 1; % = 1 pre spojite systemy
sys = simsizes(sizes);
x0=[75 57.8668 20]; % zaciatocne podmienky pre dif. rovnice
str = []; % str je prazdna matica
ts = [0 0]; % velkost periody vzorkovania, pre spojite systemy =[0 0]
 
function sys = mdlDerivatives(t,x,u) % vypocet derivaci: do tejto funkcie vkladame vlastne udaje - rovnice dynamiky
%petrolej
q3 = (1100/3600)/810;
ro3 = 810;
cp3 = 2100;
theta3=20;
%voda
q1 = (400/3600)/1000;
ro1 = 1000;
cp1 = 4200;
theta1=75;
%rrka
L = 10;
d1 = 0.025;
d2 = 0.028;
%d2=0.025+0.0015+0.0015(pretoze berieme to 
%z jednej aj druhej strany)
d3 = 0.050;
ro2 = 8930;
cp2 = 385;
lamda2 = 395;
alfa12 = 1480;
alfa23 = 750;
dz=2;
 
dA12=pi*d2*dz;
dA23=pi*d1*dz;
dV1=(pi*(d3^2-d2^2)*dz)/4;
dV2=pi*((d2^2-d1^2)*dz/4);
dV3=pi*((d1^2)*dz/4);
 
T1=(dV1*ro1*cp1)/(alfa12*dA12);
T2=(dV2*ro2*cp2)/(alfa12*dA12+alfa23*dA23);
T3=(dV3*ro3*cp3)/(alfa23*dA23);
 
w1=q1/(pi*(d3^2-d2^2)/4);
w3=q3/(pi*(d1^2)/4);
 
Z21=(alfa12*dA12)/(alfa12*dA12+alfa23*dA23);
Z23=(alfa23*dA23)/(alfa12*dA12+alfa23*dA23);
  
x(2)= Z21*x(1)+Z23*x(3);
sys(1)= -x(1)/(T1*w1)+x(2)/(T1*w1);
sys(3) = x(2)/(T3*w3)-x(3)/(T3*w3);
  
function sys = mdlOutputs(t,x,u)  % vypocet vystupov: do tejto funkcie vkladame vlastne udaje - rovnice vystupu
%petrolej
q3 = (1100/3600)/810;
ro3 = 810;
cp3 = 2100;
theta3=20;
%voda
q1 = (400/3600)/1000;
ro1 = 1000;
cp1 = 4200;
theta1=75;
%rrka
L = 10;
d1 = 0.025;
d2 = 0.028;
d3 = 0.050;
ro2 = 8930;
cp2 = 385;
lamda2 = 395;
alfa12 = 1480;
alfa23 = 750;
dz=2;
 
dA12=pi*d2*dz;
dA23=pi*d1*dz;
dV1=(pi*(d3^2-d2^2)*dz)/4;
dV2=pi*((d2^2-d1^2)*dz/4);
dV3=pi*((d1^2)*dz/4);
 
T1=(dV1*ro1*cp1)/(alfa12*dA12);
T2=(dV2*ro2*cp2)/(alfa12*dA12+alfa23*dA23);
T3=(dV3*ro3*cp3)/(alfa23*dA23);
 
w1=q1/(pi*(d3^2-d2^2)/4);
w3=q3/(pi*(d1^2)/4);
 
Z21=(alfa12*dA12)/(alfa12*dA12+alfa23*dA23);
Z23=(alfa23*dA23)/(alfa12*dA12+alfa23*dA23);
  
sys(1)=x(1);
sys(2)=x(3);

% sys=[];

