function [sys,x0,str,ts] = spojs2(t,x,u,flag)
switch flag,
case 0
[sys,x0,str,ts] = mdlInitializeSizes;
case 1
sys = mdlDerivatives(t,x,u);
case 3
sys = mdlOutputs(t,x,u);
case {2, 4, 9}
sys = [];
otherwise
error(['unhandled flag = ',num2str(flag)]);
end;
function [sys,x0,str,ts] = mdlInitializeSizes % inicializacia: do tejto funkcie vkladame vlastne udaje
sizes = simsizes;
sizes.NumContStates = 2; % pocet spojitych stavov
sizes.NumDiscStates = 0; % pocet diskretnych stavov
sizes.NumOutputs = 2; % pocet vystupov
sizes.NumInputs = 2; % pocet vstupov
sizes.DirFeedthrough = 0; % = 0 v pripade, ze v rovniciach vystupu nevystupuje u
sizes.NumSampleTimes = 1; % = 1 pre spojite systemy
sys = simsizes(sizes);
x0=[75 20]; % zaciatocne podmienky pre dif. rovnice
str = []; % str je prazdna matica
ts = [0 0]; % velkost periody vzorkovania, pre spojite systemy =[0 0]
 
 
function sys = mdlDerivatives(t,x,u) 
% Voda:
q1  = 1.15e-004; 
ro1 = 998;    
cp1 = 4186;     
%Petrolej:
q3  = 3.77e-004; 
ro3 = 810;       
cp3 = 2100;      
 
%rozmery prierezu
d1 = 0.025;      
d2 = 0.0265;     
d3 = 0.050;      
d  = 0.0015;    
%dlzka vymennika:
L = 10;
 
%udaje o rozhrani
alfa1  = 1480;   
alfa3  = 750;    
lambda = 395;    
ro = 8930;        
cp = 385;     
 
%konsanty vypocet: 
koef1=1/(1/alfa1+(d1/(2*lambda))*log(d1/d2)+d1/(alfa3*d2))
koef3=1/(1/alfa3+(d2/(2*lambda))*log(d2/d1)+d2/(alfa1*d1))
 
T3=(ro3*(d3^2-d2^2)*cp3)/(koef3*d2*4)
T1=(d1*ro1*cp1)/(4*koef1)
w1 = (4*q1)/(pi*d1^2)
w3 = (4*q3)/(pi*(d3^2-d2^2))
 
 
%rovnice
sys(1) =-(1/(T1*w1))*x(1)+(1/(T1*w1))*x(2);
sys(2) =-(1/(T3*w3))*x(2)+(1/(T3*w3))*x(1);
 
 
function sys = mdlOutputs(t,x,u) 
sys(1) = x(1);
sys(2) = x(2);

